
from LIB.MIDDLE.FaultClass.V1_0_0.faultclass import *
import pymysql
import datetime
import pandas as pd
from LIB.BACKEND import DBManager
dbManager = DBManager.DBManager()
from sqlalchemy import create_engine
from urllib import parse
import datetime, time
from apscheduler.schedulers.blocking import BlockingScheduler
import traceback
import pickle
from keras.models import load_model
import logging
import logging.handlers
import os
import re


#...................................故障检测函数......................................................................................................................
def diag_cal():
    global SNnums
    global scaler1,scaler2,model1,model2,col1,col2,time_steps1,time_steps2

    start=time.time()
    now_time=datetime.datetime.now()
    start_time=now_time-datetime.timedelta(hours=1)
    start_time=start_time.strftime('%Y-%m-%d %H:%M:%S')
    end_time=now_time.strftime('%Y-%m-%d %H:%M:%S')

    #数据库配置
    host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port=3306
    db='safety_platform'
    user='qx_read'
    password='Qx@123456'

    #读取结果库数据......................................................
    param='product_id,start_time,end_time,diff_min,SOC,AnoScoreV_sum_max,AnoScoreV_max_max,AnoScoreT_sum_max,AnoScoreT_max_max'
    tablename='fault_detection'
    mysql = pymysql.connect (host=host, user=user, password=password, port=port, database=db)
    cursor = mysql.cursor()
    sql =  "select {} from {} where end_time='0000-00-00 00:00:00'".format(param,tablename)
    cursor.execute(sql)
    res = cursor.fetchall()
    df_diag_ram= pd.DataFrame(res,columns=param.split(','))
    

    db_res_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, parse.quote_plus(password), host, port, db
        ))


    #调用主函数................................................................................................................................................................
    for sn in SNnums:
        try:
            df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms'])
            data_bms = df_data['bms']
            data_bms['sn']=sn
            if len(data_bms)>0:
                logger.info("SN: {} 数据开始预处理".format(sn))
                data_fea1=features1(data_bms)
                data_fea2=features2(data_bms)
                logger.info("SN: {} 数据开始模型预测".format(sn))
                df_res1=pred(data_fea1,model1,scaler1,col1,end_time,time_steps1)
                df_res2=pred(data_fea2,model2,scaler2,col2,end_time,time_steps2)
                df_diag_ram_sn=df_diag_ram[df_diag_ram['product_id']==sn]
                res_new1,res_update1=arrange2(df_diag_ram_sn,df_res1,start_time,'B板采样失效')
                res_new2,res_update2=arrange2(df_diag_ram_sn,df_res2,start_time,'传感器_电芯NTC漂移')
               
                if len(res_update1)>0:
                    cursor.execute("DELETE FROM fault_class WHERE end_time = '0000-00-00 00:00:00' and product_id='{}' and fault_class='{}'".format(sn,'B板采样失效'))
                    mysql.commit()
                    res_update1.to_sql("fault_class",con=db_res_engine, if_exists="append",index=False)
                res_new1.to_sql("fault_class",con=db_res_engine, if_exists="append",index=False)
                if len(res_update2)>0:
                    cursor.execute("DELETE FROM fault_class WHERE end_time = '0000-00-00 00:00:00' and product_id='{}' and fault_class='{}'".format(sn,'传感器_电芯NTC漂移'))
                    mysql.commit()
                    res_update2.to_sql("fault_class",con=db_res_engine, if_exists="append",index=False)
                res_new2.to_sql("fault_class",con=db_res_engine, if_exists="append",index=False)
            
                        #新增结果存入结果库................................................................


            # end=time.time()
            # print(end-start)  
                
        except Exception as e:
            logger.error(str(e))
            logger.error(traceback.format_exc())

    cursor.close()
    mysql.close()

#...............................................主函数起定时作用.......................................................................................................................
if __name__ == "__main__":
    
    # 日志
    log_path = 'log/'
    if not os.path.exists(log_path):
        os.makedirs(log_path)
    logger = logging.getLogger("main")
    logger.setLevel(logging.DEBUG)
    
     # 根据日期滚动(每天产生1个文件)
    fh = logging.handlers.TimedRotatingFileHandler(filename='{}/main_info.log'.format(log_path), when="D", interval=1, backupCount=30,
                                                    encoding="utf-8")
    formatter = logging.Formatter("%(asctime)s - %(name)s-%(levelname)s %(message)s")
    fh.suffix = "%Y-%m-%d_%H-%M-%S"
    fh.extMatch = re.compile(r"^\d{4}-\d{2}-\d{2}_\d{2}-\d{2}-\d{2}")
    fh.setFormatter(formatter)
    fh.setLevel(logging.INFO)
    logger.addHandler(fh)

    fh = logging.handlers.TimedRotatingFileHandler(filename='{}/main_error.log'.format(log_path), when="D", interval=1, backupCount=30,
                                                    encoding="utf-8")
    formatter = logging.Formatter("%(asctime)s - %(name)s-%(levelname)s %(message)s")
    fh.suffix = "%Y-%m-%d_%H-%M-%S"
    fh.extMatch = re.compile(r"^\d{4}-\d{2}-\d{2}_\d{2}-\d{2}-\d{2}")
    fh.setFormatter(formatter)
    fh.setLevel(logging.ERROR)
    logger.addHandler(fh)

    logger.info("pid is {}".format(os.getpid()))
    
     # # 更新sn列表
    host='rm-bp10j10qy42bzy0q7.mysql.rds.aliyuncs.com'
    port=3306
    db='qixiang_oss'
    user='qixiang_oss'
    password='Qixiang2021'
    conn = pymysql.connect(host=host, port=port, user=user, password=password, database=db)
    cursor = conn.cursor()
    cursor.execute("select sn, imei, add_time from app_device where status in (1,2,3)")
    res = cursor.fetchall()
    df_sn = pd.DataFrame(res, columns=['sn', 'imei', 'add_time'])
    df_sn = df_sn.reset_index(drop=True)
    conn.close();
    
    SNnums = list(df_sn['sn'])
    
    scaler1=pickle.load(open('D:/deploy/python_platform/data_analyze_platform/LIB/MIDDLE/FaultClass/V1_0_0/models/scaler_B板采样失效.pkl','rb'))
    scaler2=pickle.load(open('D:/deploy/python_platform/data_analyze_platform/LIB/MIDDLE/FaultClass/V1_0_0/models/scaler_传感器_电芯NTC漂移.pkl','rb'))
    model1=load_model('D:/deploy/python_platform/data_analyze_platform/LIB/MIDDLE/FaultClass/V1_0_0/models/model_B板采样失效.h5')
    model2=load_model('D:/deploy/python_platform/data_analyze_platform/LIB/MIDDLE/FaultClass/V1_0_0/models/model_传感器_电芯NTC漂移.h5')
    col1=['B板采样失效','正常']
    col2=['传感器_电芯NTC漂移','正常']
    time_steps1=60
    time_steps2=60
    logger.info("模型加载完成")

    diag_cal()
    #定时任务.......................................................................................................................................................................
    scheduler = BlockingScheduler()
    scheduler.add_job(diag_cal, 'interval', hours=1)

    try:  
        scheduler.start()
    except Exception as e:
        scheduler.shutdown()
        logger.error(str(e))
        logger.error(traceback.format_exc())